**$NOKEYWORDS$
************************************
* Version controll commands and functions 
************************************
*****************
* User commands
*****************
*Add and remove users
FUNCTION ssadmin
WAIT WINDOW "It is not necessary to run ADMIN command" NOWAIT 
RETURN (.T.)

***************************
* Projects Commands *
***************************
*Add new project
PROCEDURE ssaddproj
PARAMETERS cProject
RETURN (.T.)

*Remove project
PROCEDURE ssremproject
PARAMETERS cProject
RETURN (.T.)

*Select project
PROCEDURE ssseleproject
PARAMETERS cProject
RETURN (.T.)

*********************************
*Module commands and functions
*********************************

* Add New Module command
FUNCTION fAdd
RETURN('')

* Add New Module command
FUNCTION fRemove
RETURN('')

FUNCTION fPurge
RETURN('')


FUNCTION fShare
RETURN('')

* Check In command
FUNCTION fCheckin
RETURN('') 

* Check Out command
FUNCTION fCheckout
RETURN('')

* History report command
FUNCTION fHistory
RETURN('')

* Status report command
FUNCTION fStatus
RETURN('')

* FUNCTIONS
* Add and Check In module
FUNCTION AddNew
PARAMETERS filename
RETURN("")

* Remove file from the project
FUNCTION RemoveFile
PARAMETERS filename
RETURN("")

* Permanently delete a Removed file from the project
FUNCTION PurgeFile
PARAMETERS filename
RETURN("")

* Share modules
FUNCTION sharemode
PARAMETERS filename,cProjname
RETURN("")

* Check Out module 
FUNCTION checkout
PARAMETERS m.path,filename
=SETATTR(m.path+filename,"Normal")
COPY FILE (m.path+m_storedir+"\"+filename) TO (m.path+filename) 

* Check In module
FUNCTION checkin
PARAMETERS m.path,filename
=SETATTR(m.path+m_storedir+"\"+filename,"Normal")
COPY FILE (m.path+filename) TO (m.path+m_storedir+"\"+filename)
=SETATTR(m.path+filename,"ReadOnly")
=SETATTR(m.path+m_storedir+"\"+filename,"ReadOnly")


* Dispaly module history
FUNCTION vhistory
  PARAMETERS filename
  RETURN ("")
  
* Display module status 
FUNCTION vstatus
  PARAMETERS filename
  RETURN("")

* PROCEDURES *************
PROCEDURE ShareFiles
* Makes the specified file a member of a current project
PARAMETERS m.project,m.firstname,m.secname,m.cdxname
RETURN (.T.)

PROCEDURE ShareModule
RETURN (.T.)


* Create batch file to check in  modules
PROCEDURE CheIn
PARAMETERS m.path,m.firstname,m.secname,m.cdxname,cFirst
SET PROC TO (home_dir+"FPROC.PRG")
SET TEXT ON 
SET TEXT TO (cWorkFilDir+"CHKERR.ERR") NOSHOW
\**<<m.path+m.firstname>> 
SET TEXT TO 
SET TEXT OFF
=CHECKIN(m.path,m.firstname)           
IF !EMPTY(m.secname)
       =CHECKIN(m.path,m.secname)               
ENDIF
IF !EMPTY(m.cdxname)
       =CHECKIN(m.path,m.cdxname)               
ENDIF

* Create batch file to check out modules
PROCEDURE CheOut
PARAMETERS m.path,m.firstname,m.secname,m.cdxname
SET PROC TO (home_dir+"FPROC.PRG")
SET TEXT ON  
SET TEXT TO (cWorkFilDir+"CHKERR.ERR") NOSHOW
\**<<m.path+m.firstname>> 
IF !FILE(m.path+m_storedir+"\"+m.firstname)
  \Module <<m.firstname>> is not a controlled module
  SET TEXT TO 
  SET TEXT OFF
  RETURN (.T.)
ENDIF
IF getattr(m.path+m.firstname) != "ReadOnly" 
  \Writeable work file <<m.firstname>> already exists
  SET TEXT TO 
  SET TEXT OFF
  RETURN (.T.)
ENDIF
SET TEXT TO 
SET TEXT OFF
=CHECKOUT(m.path,m.firstname)             
IF !EMPTY(m.secname)
        =CHECKOUT(m.path,m.secname)              
ENDIF !EMPTY(m.secname)
IF !EMPTY(m.cdxname)
        =CHECKOUT(m.path,m.cdxname)                
ENDIF !EMPTY(m.cdxname)

PROCEDURE DefStatus
    PRIVATE cArea, cFilext 
    SET PROC TO (home_dir+"FPROC.PRG")
    SET TEXT ON
    SET TEXT TO (cWorkFilDir+"STATUS.TXT")  ADDITIVE NOSHOW
    cArea = SELECT()
    cFilext   = ALLTRIM(UPPER(SUBSTR(name,AT(".",name)+1)))
    IF cFilext = "DBF" .AND. controlled = 'Str'
         cFilext = "STR"
    ENDIF     
    =OPENDBF("DB_PJFL","DB_PJFL")
    SET ORDER TO extension
    IF SEEK(cFilext)
       m.secname = secname
       m.cdxname = cdxname
    ELSE
       m.secname = ""
       m.cdxname = ""
    ENDIF       
    SELECT (cArea)
    =CheckContr( SUBSTR(name,1,AT(".",name)) + cFilext ) 
    IF !EMPTY(m.secname) .AND. ;
       FILE(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname ))
       =CheckContr(strtran( upper( name) ,"."+cFilext ,"."+m.secname ))
    ENDIF
    IF !EMPTY(m.cdxname) .AND. ;
       FILE(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname ))
       =CheckContr(strtran( upper( name) ,"."+cFilext ,"."+m.cdxname ))
    ENDIF
    =CheckCkOut(SUBSTR(name,1,AT(".",name)) + cFilext )      
    IF !EMPTY(m.secname) .AND. ;
      FILE(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname ))
      =CheckCkOut(strtran( upper( name) ,"."+cFilext ,"."+m.secname ))
    ENDIF
    IF !EMPTY(m.cdxname) .AND. ;
      FILE(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname ))
      =CheckCkOut(strtran( upper( name) ,"."+cFilext ,"."+m.cdxname ))
    ENDIF
  \
  SELECT (cArea)
RETURN (.T.)

FUNCTION CheckContr
* Check if file is controlled
PARAMETERS filename
* Check if file under control
IF !FILE(cFileDir+m_storedir+"\"+ALLTRIM(filename))
   \Capcon: Module <<ALLTRIM(filename)>> is not a controlled module
ENDIF

FUNCTION  CheckCkOut
* Check if file is checkout
PARAMETERS filename,lMode     
IF(mode) = "ChO"
     \<<Alltrim(filename)>>, <<Year(check_date)>> <<CMONTH(check_date)>> <<Day(check_date)>>, <<check_time>>, <<check_by>>
     \Capcon: Module checked-out
ELSE
     \No modules checked-out    
ENDIF
 
PROCEDURE DefHistory
    PRIVATE m.fullname
    SET TEXT ON
    SET TEXT TO (cWorkFilDir+"HISTORY.TXT")  NOSHOW
    SET PROC TO (home_dir+"FPROC.PRG")
    cArea = SELECT()
    cFilext   = ALLTRIM(UPPER(SUBSTR(name,AT(".",name)+1)))
    IF cFilext = "DBF" .AND. controlled = 'Str'
         cFilext = "STR"
    ENDIF     
    =OPENDBF("DB_PJFL","DB_PJFL")
    SET ORDER TO extension
    IF SEEK(cFilext)
       m.secname = secname
       m.cdxname = cdxname
       m.descrip = ALLTRIM(descrip)
    ELSE
       m.secname = ""
       m.cdxname = ""
    ENDIF       
	  m.fullname = upper( cFileDir+name )
	  m.fullname = SUBSTR(m.fullname,1,RAT(".",m.fullname)-1)
    cWinTitle  = "History for "+m.descrip  +" "+m.fullname
 
    SELECT (cArea)
    =CheckContr(SUBSTR(name,1,AT(".",name)) + cFilext)
    IF !EMPTY(m.secname) .AND. ;
       FILE(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname ))
       =CheckContr(strtran( upper( name) ,"."+cFilext ,"."+m.secname ))
    ENDIF
    IF !EMPTY(m.cdxname) .AND. ;
       FILE(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname ))
       =CheckContr(strtran( upper( name) ,"."+cFilext ,"."+m.cdxname ))
    ENDIF
    =CheckCkOut(name)
    IF !EMPTY(m.secname) .AND. ;
       FILE(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname ))
      =CheckCkOut(strtran( upper( name) ,"."+cFilext ,"."+m.secname ))
    ENDIF
    IF !EMPTY(m.cdxname) .AND. ;
      FILE(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname ))
      =CheckCkOut(strtran( upper( name) ,"."+cFilext ,"."+m.cdxname ))
    ENDIF
  \
RETURN (.T.)

* Refresh from Local directory
PROCEDURE rfrhost
RETURN (.T.)


PROCEDURE RemoveModule
PARAMETERS m.firstname
RETURN (.T.)

PROCEDURE RemovePurge 
* Remove files from the project and permanently delete from project
RETURN (.T.)


* make STORAGE directory
PROCEDURE CreaAll
PARAMETERS m.projname,cDir_to_create
PRIVATE cdir,curarea
curarea = SELECT()
*cdir = sys(5)+CURDIR()
*SET DEFA TO (cDir_to_create)
=SETDIR(cDir_to_create)
=MAKEDIR(cDir_to_create+m_storedir)
*SET DEFA TO (cdir)
=SETDIR(home_dir)


******
* Test reading of Error File from Checkin/Checkout:
* 02/03/93  (rg)
*    If you remove "*" from delete command after "if lOk"
*    statement, it will delete records for successful entries
*    leaving only the errors (I think this is better...).
*    Note that there can be 1 OR 2 records for an error.
*    We should leave both.
*
* Current directory - cSpecFilDir
*
procedure checktst
private nModRecNo, nCurRec, cModName, lOk, lDone, lFirst,oldarea,wtop
curarea = SELECT()

create table (cWorkFilDir+"chkerr") ( Result C(100) , ;
                      Module C(50) , ;
                      IsError L )

if file( cWorkFilDir+"CHKERR.DBF" )
  use (cWorkFilDir+"CHKERR") excl
  zap
  append from CHKERR.ERR SDF
  *DELETE FILE CHKERR.ERR
  IF RECCOUNT() = 0
     RETURN
  ENDIF   
  go top
  IF EMPTY(Module)
    SKIP
  ENDIF  
  lDone = .F.
  lFirst = .T.
  nModRecNo = recno()  && starting record number
  cModName  = substr( Result, 3 )
  
  *lOk = .F.  && indicator that operation was successful
   lOk = .T.  && indicator that operation was successful

  do while !lDone
    lDone = eof()
    if !lFirst and ( substr( Result, 1, 2 ) = "**" or eof() )
      nCurRec = min( recno(), reccount() )
      goto nModRecNo
      delete   && we don't need "**" indicator record any more...
      do while ( recno() < nCurRec or nCurRec = reccount() ) and !eof()
        replace module with cModName
        replace IsError with !lOK
        if lOk  &&  delete references to OK operations
          * delete  && temporary block for testing
        endif
        skip
      enddo
      goto nCurRec
      nModRecNo = recno()  && starting record number
      cModName  = substr( Result, 3 )
      *lOk = .F.
      lOk = .T.
    else
      IF not "**" $ Result 
        if "same as" $ Result or ;
          ("checked out" $ result and not "already" $ Result  ;
          and not "do not have" $ Result) or ;
          ( "created" $ Result and not "not" $ Result ) or ;
          "extracted" $ Result or "updated" $ Result or ;
          "checked out by " + trim( m_userid ) $ Result or ;
          "created" $ Result .or. "unlocked" $ Result ;
          .OR. ALLTRIM(Result) $ cModName 
           *lOk = .T.
        else 
           lOk = .f.
        endif
      ENDIF
    endif
    lFirst = .F.
    skip
  enddo
  pack
else
  wait "Error Opening Checkin/out Error File!" window
endif
SELECT *;
  FROM CHKERR;  
  WHERE IsError;
  INTO CURSOR temperr
IF USED("chkerr")
  USE IN chkerr
ENDIF
SELECT (curarea)
return

FUNCTION vcstr
* Indicate that module is not a controlled
RETURN("is not a controlled module")