**$NOKEYWORDS$
************************************
* Version controll commands and functions 
* PVCS
************************************
*****************
* User commands
*****************
*Add and remove users
FUNCTION ssadmin
WAIT WINDOW "It is not necessary to run ADMIN command" NOWAIT 
RETURN (.T.)

***************************
* Projects Commands *
***************************
*Add new project
PROCEDURE ssaddproj
PARAMETERS cProject
RETURN (.T.)

*Remove project
PROCEDURE ssremproject
PARAMETERS cProject
RETURN (.T.)

*Select project
PROCEDURE ssseleproject
PARAMETERS cProject
RETURN (.T.)

*********************************
*Module commands and functions
*********************************

* Add New Module command
FUNCTION fAdd
RETURN('')

* Add New Module command
FUNCTION fRemove
RETURN('')

FUNCTION fPurge
RETURN('')


FUNCTION fShare
RETURN('')

* Check In command
FUNCTION fCheckin
RETURN('PUT -C{CONFIGFILE} -U -Y -T@{COMMENTS} -M@{COMMENTS} -XO+Etemp.txt {FILE} >> temp1.txt') 

* Check In and Lock
FUNCTION fChlock
RETURN('PUT -C{CONFIGFILE} -L -F -Y -T@{COMMENTS} -M@{COMMENTS} -XO+Etemp.txt {FILE} >> temp1.txt') 

* Check Out command
FUNCTION fCheckout
RETURN('GET -C{CONFIGFILE} -L -XO+Etemp.txt {FILE} >> temp1.txt')

* Display  command
FUNCTION fDisplay
RETURN('GET -C{CONFIGFILE} -P -R{REVISION} -XO{TARGET} {FILE} ')

* History report command
FUNCTION fHistory
RETURN('VLOG -C{CONFIGFILE} -BR -XO+Etemp.txt {FILE} ')

* History report command for latest version
FUNCTION fcheckver
RETURN('VLOG -C{CONFIGFILE} -BR -XO+Etemp.txt {FILE} ')

* Status report command
FUNCTION fStatus
RETURN('VLOG -C{CONFIGFILE} -R  -XO+Etemp.txt {FILE} ')

* FUNCTIONS
* Add and Check In module
FUNCTION AddNew
PARAMETERS filename
RETURN("")

* Remove file from the project
FUNCTION RemoveFile
PARAMETERS filename
RETURN("")

* Permanently delete a Removed file from the project
FUNCTION PurgeFile
PARAMETERS filename
RETURN("")

* Share modules
FUNCTION sharemode
PARAMETERS filename,cProjname
RETURN("")

* Check Out module 
FUNCTION checkout
PARAMETERS filename,m.checkout
m.checkout = STRTRAN(fCheckout(),"{FILE}","@FILERESP")
m.checkout = STRTRAN(m.checkout,"{CONFIGFILE}",;
             SUBSTR(filename,1,RAT("\",filename))+"VCS.CFG")
RETURN(m.checkout)

* Display module 
FUNCTION display
PARAMETERS filename,target
PRIVATE display
m.display = STRTRAN(fdisplay(),"{FILE}","@FILERESP")
m.display = STRTRAN(m.display,"{CONFIGFILE}",;
             SUBSTR(filename,1,RAT("\",filename))+"VCS.CFG")
m.display = STRTRAN(m.display,"{TARGET}",target)
m.display = STRTRAN(m.display,"{REVISION}",cVer)
RETURN(m.display)


* Check In module
FUNCTION checkin
PARAMETERS filename
PRIVATE m.checkin
m.checkin = STRTRAN(fCheckin(),"{FILE}","@FILERESP")
m.checkin = STRTRAN(m.checkin,"{CONFIGFILE}",;
            SUBSTR(filename,1,RAT("\",filename))+"VCS.CFG")
m.checkin = STRTRAN(m.checkin,"{COMMENTS}",m.commfile)
RETURN(ALLTRIM(m.checkin))

* Check In module and lock
FUNCTION checkinlock
PARAMETERS filename
PRIVATE m.checkin
m.checkin = STRTRAN(fChlock(),"{FILE}","@FILERESP")
m.checkin = STRTRAN(m.checkin,"{CONFIGFILE}",;
            SUBSTR(filename,1,RAT("\",filename))+"VCS.CFG")
m.checkin = STRTRAN(m.checkin,"{COMMENTS}",m.commfile)
RETURN(ALLTRIM(m.checkin))

* Check In module without comment
FUNCTION checkinnc
PARAMETERS filename
PRIVATE m.checkin
m.checkin = STRTRAN(fCheckin(),"{FILE}","@FILERESP")
m.checkin = STRTRAN(m.checkin,"{CONFIGFILE}",;
            SUBSTR(filename,1,RAT("\",filename))+"VCS.CFG")
m.checkin = STRTRAN(m.checkin,"{COMMENTS}","")
RETURN(ALLTRIM(m.checkin))

* Create respond file for Check Out/In module command
FUNCTION setresp
PRIVATE m.commentline,nArea
IF TYPE("comments") = "U" .OR.  SUBSTR(comments,1,2) = "**"
      m.commentline = '' 
ELSE
 m.commentline = IIF( EMPTY(comments) ," " ,comments)
 IF m_delimiter $ m.commentline
      m.commentline = SUBSTR(m.commentline,1,AT(m_delimiter,m.commentline)-1)
 ENDIF
ENDIF
nArea = SELECT()
SELE 0
CREATE CURSOR TCursor (temp M)
APPEND BLANK
REPLACE TCursor.temp WITH  m.commentline
COPY MEMO TCursor.temp TO (m.commresp)
USE IN TCursor
SELE (nArea)

* Dispaly module history
FUNCTION vhistory
  PARAMETERS filename
  m.history = STRTRAN(m_history,"{FILE}",filename)
  m.history = STRTRAN(m.history,"{CONFIGFILE}",;
            SUBSTR(filename,1,RAT("\",filename))+"VCS.CFG")

  RETURN(m.history) 

* Dispaly module history
FUNCTION VCHKVER
  PARAMETERS filename
  m.history = STRTRAN(m_history,"{FILE}",filename)
  m.history = STRTRAN(m.history,"{CONFIGFILE}",;
            SUBSTR(filename,1,RAT("\",filename))+"VCS.CFG")

  RETURN(m.history) 

* Dispaly module version
FUNCTION vversion
  PARAMETERS filename
  m.history = STRTRAN(m_history,"{FILE}",filename)
  m.history = STRTRAN(m.history,"{CONFIGFILE}",;
            SUBSTR(filename,1,RAT("\",filename))+"VCS.CFG")

  RETURN(m.history) 


* Display module status 
FUNCTION vstatus
  PARAMETERS filename
  m.status = STRTRAN(m_status,"{FILE}",filename)

  m.status = STRTRAN(m.status,"{CONFIGFILE}",;
            SUBSTR(filename,1,RAT("\",filename))+"VCS.CFG")
  RETURN(m.status) 

* PROCEDURES *************
PROCEDURE ShareFiles
* Makes the specified file a member of a current project
PARAMETERS m.project,m.firstname,m.secname,m.cdxname
RETURN (.T.)

PROCEDURE ShareModule
RETURN (.T.)


* Create batch file to check in  modules
PROCEDURE CheIn
PARAMETERS m.path,m.firstname,m.secname,m.cdxname,cFirst, m.commfile
PRIVATE m.commresp,nPos
nPos = RAT(".",m.firstname)
m.commresp = cWorkFilDir+SUBSTR(m.firstname,1,nPos)+"@"+SUBSTR(m.firstname,nPos+2)
m.commfile = SUBSTR(m.firstname,1,nPos)+"@"+SUBSTR(m.firstname,nPos+2)
SET TEXTMERGE TO (cWorkFilDir+"setall.bat") ADDITIVE NOSHOW
\ECHO **<<m.path+m.firstname>> >>chkerr.err
\ECHO <<m.path+m.firstname>>
=SETRESP()
\ECHO <<m.path+m.firstname>> > FILERESP.
\<<CHECKIN(m.path+m.firstname)>>          
\COPY chkerr.err+temp.txt+temp1.txt chkerr.err > temp.
\ERASE temp.txt
\ERASE temp1.txt
IF !EMPTY(m.secname)
       \ECHO **<<m.path+m.secname>> >>chkerr.err
       \ECHO <<m.path+m.secname>> > FILERESP.
       \<<CHECKIN(m.path+m.secname)>>           
       \COPY chkerr.err+temp.txt+temp1.txt chkerr.err > temp.
       \ERASE temp.txt
       \ERASE temp1.txt
ENDIF
IF !EMPTY(m.cdxname)
       \ECHO **<< m.path+m.cdxname >> >>chkerr.err
       \ECHO <<m.path+m.cdxname>> > FILERESP.
       \<<CHECKIN(m.path+m.cdxname)>>              
       \COPY chkerr.err+temp.txt+temp1.txt chkerr.err > temp.
       \ERASE temp.txt
       \ERASE temp1.txt
ENDIF
\ERASE <<m.commresp>>
\erase temp.

* Create batch file to check in  modules and lock
PROCEDURE CheInLock
PARAMETERS m.path,m.firstname,m.secname,m.cdxname
PRIVATE m.commresp,nPos
nPos = RAT(".",m.firstname)
m.commresp = cWorkFilDir+SUBSTR(m.firstname,1,nPos)+"@"+SUBSTR(m.firstname,nPos+2)
m.commfile = SUBSTR(m.firstname,1,nPos)+"@"+SUBSTR(m.firstname,nPos+2)
SET TEXTMERGE TO (cWorkFilDir+"setall.bat") ADDITIVE NOSHOW
\ECHO **<<m.path+m.firstname>> >>chkerr.err
\ECHO <<m.path+m.firstname>>
=SETRESP()
\ECHO <<m.path+m.firstname>> > FILERESP.
\<<checkinlock(m.path+m.firstname)>>          
\COPY chkerr.err+temp.txt+temp1.txt chkerr.err > temp.
\ERASE temp.txt
\ERASE temp1.txt
IF !EMPTY(m.secname)
       \ECHO **<<m.path+m.secname>> >>chkerr.err
       \ECHO <<m.path+m.secname>> > FILERESP.
       \<<checkinlock(m.path+m.secname)>>           
       \COPY chkerr.err+temp.txt+temp1.txt chkerr.err > temp.
       \ERASE temp.txt
       \ERASE temp1.txt
ENDIF
IF !EMPTY(m.cdxname)
       \ECHO **<< m.path+m.cdxname >> >>chkerr.err
       \ECHO <<m.path+m.cdxname>> > FILERESP.
       \<<checkinlock(m.path+m.cdxname)>>              
       \COPY chkerr.err+temp.txt+temp1.txt chkerr.err > temp.
       \ERASE temp.txt
       \ERASE temp1.txt
ENDIF
\ERASE <<m.commresp>>
\erase temp.


FUNCTION CheckVersion
PARAMETERS m.path,m.firstname,m.secname,m.cdxname
    \ECHO **<<m.path+m.firstname>> >> STATUS.TXT
    \ECHO <<m.path+m.firstname>> > FILERESP.
    \<<VCHKVER(m.path+m.firstname)>>
    \COPY status.txt+temp.txt status.txt > temp.
    IF !EMPTY(m.secname) .AND. ;
      FILE(m.path+m.secname ))
      \ECHO **<<m.path+m.secname )>> >> STATUS.TXT
      \ECHO <<m.path+m.secname )>> > FILERESP.
      \<<VCHKVER(m.path+m.secname ))>> 
      \COPY status.txt+temp.txt status.txt > temp.
    ENDIF
    IF !EMPTY(m.cdxname) .AND. ;
      FILE(m.path+m.cdxname ))
      \ECHO **<<m.path+m.secname )>> >> STATUS.TXT
      \ECHO <<m.path+m.cdxname )>> > FILERESP.
      \<<VCHKVER(m.path+m.cdxname ))>> 
      \COPY status.txt+temp.txt status.txt > temp.
  ENDIF

* Create batch file to check out modules
PROCEDURE CheOut
PARAMETERS m.path,m.firstname,m.secname,m.cdxname
SET TEXTMERGE TO (cWorkFilDir+"setall.bat") ADDITIVE NOSHOW
\ECHO **<<m.path+m.firstname>> >>chkerr.err 
\ECHO <<m.path+m.firstname>>
\ECHO <<m.path+m.firstname>> > FILERESP.
\<<CHECKOUT(m.path+m.firstname)>>            
\COPY chkerr.err+temp.txt+temp1.txt  chkerr.err > temp.
\ERASE temp.txt
\ERASE temp1.txt
IF !EMPTY(m.secname)
        \ECHO **<<m.path+m.secname>> >>chkerr.err 
        \ECHO <<m.path+m.secname>> > FILERESP.
        \<<CHECKOUT(m.path+m.secname)>>             
        \COPY chkerr.err+temp.txt++temp1.txt  chkerr.err > temp.
        \ERASE temp.txt
        \ERASE temp1.txt
ENDIF !EMPTY(m.secname)
IF !EMPTY(m.cdxname)
        \ECHO **<<m.path+m.cdxname>> >>chkerr.err
        \ECHO <<m.path+m.cdxname>> > FILERESP.
        \<<CHECKOUT(m.path+m.cdxname)>>               
        \COPY chkerr.err+temp.txt+temp1.txt  chkerr.err > temp.
        \ERASE temp.txt
        \ERASE temp1.txt
ENDIF !EMPTY(m.cdxname)
\erase temp.

* Create batch file to check out non-terminal version
PROCEDURE CheOutNt
PARAMETERS m.path,m.firstname,m.secname,m.cdxname,cMode
SET TEXTMERGE TO (cWorkFilDir+"setall.bat") ADDITIVE NOSHOW
\ECHO <<m.path+m.firstname>> > FILERESP.
IF cMode = "View"
   \<<DISPLAY(m.path+m.firstname,m.TempLoc+m.tFirstname)>>            
ELSE
   \<<DISPLAY(m.path+m.firstname,m.TempLoc+m.Firstname)>>            
ENDIF
IF !EMPTY(m.secname)
        \ECHO <<m.path+m.secname>> > FILERESP.
        IF cMode = 'View'
           \<<DISPLAY(m.path+m.secname,m.TempLoc+m.tSecname)>>             
        ELSE
           \<<DISPLAY(m.path+m.secname,m.TempLoc+m.Secname)>>             
        ENDIF 
ENDIF !EMPTY(m.secname)
IF !EMPTY(m.cdxname)
        \ECHO <<m.path+m.cdxname>> > FILERESP.
        IF cMode = 'View'
           \<<DISPLAY(m.path+m.cdxname,m.TempLoc+m.tCdxname)>>               
        ELSE
           \<<DISPLAY(m.path+m.cdxname,m.TempLoc+m.Cdxname)>>               
        ENDIF
ENDIF !EMPTY(m.cdxname)


PROCEDURE RemoveModule
PARAMETERS m.firstname
RETURN (.T.)

PROCEDURE RemovePurge 
* Remove files from the project and permanently delete from project
RETURN (.T.)

PROCEDURE DefStatus
    PRIVATE cArea, cFilext 
    SET TEXT TO (cWorkFilDir+"STATUS.TXT")  ADDITIVE NOSHOW
    \
    SET TEXT TO (cWorkFilDir+"STATUSC.BAT") ADDITIVE NOSHOW
    \@echo off
    \ECHO Processing module status...
    SET PROC TO (home_dir+"FPROC.PRG")
    cArea = SELECT()
    cFilext   = ALLTRIM(UPPER(SUBSTR(name,AT(".",name)+1)))
    IF cFilext = "DBF" .AND. controlled = 'Str'
         cFilext = "STR"
    ENDIF     
    =OPENDBF("DB_PJFL","DB_PJFL")
    SET ORDER TO extension
    IF SEEK(cFilext)
       m.secname = secname
       m.cdxname = cdxname
    ELSE
       m.secname = ""
       m.cdxname = ""
    ENDIF       
    SELECT (cArea)
    \ECHO <<cFileDir+SUBSTR(name,1,AT(".",name)) + cFilext>> 
    \ECHO ********************** > STATUS.TXT
    \ECHO <<cFileDir+SUBSTR(name,1,AT(".",name)) + cFilext>> > FILERESP.
    \<<VSTATUS(cFileDir+SUBSTR(name,1,AT(".",name)) + cFilext)>>
    \COPY status.txt+temp.txt status.txt > temp.
    IF !EMPTY(m.secname) .AND. ;
       FILE(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname )))
       \ECHO ********************** >> STATUS.TXT
       \ECHO <<cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname ))>> > FILERESP.
       \<<VSTATUS(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname )))>> 
       \COPY status.txt+temp.txt status.txt > temp.
    ENDIF
    IF !EMPTY(m.cdxname) .AND. ;
       FILE(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname ))
       \ECHO ********************** >> STATUS.TXT
       \ECHO <<cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname )>> > FILERESP.
       \<<VSTATUS(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname ))>> 
       \COPY status.txt+temp.txt status.txt > temp.
    ENDIF
  \
  SELECT (cArea)
RETURN (.T.)


 
PROCEDURE DefHistory
    PRIVATE m.fullname, m.firstname, m.secname, m.cdxname, cArea, m.descrip
    SET TEXT ON
    SET TEXT TO (cWorkFilDir+"HISTORYC.BAT") ADDITIVE NOSHOW
    \@echo off
    \ECHO Processing module history...
     SET PROC TO (home_dir+"FPROC.PRG")
    cArea = SELECT()
    cFilext   = ALLTRIM(UPPER(SUBSTR(name,AT(".",name)+1)))
    IF cFilext = "DBF" .AND. controlled = 'Str'
         cFilext = "STR"
    ENDIF     
    =OPENDBF("DB_PJFL","DB_PJFL")
    SET ORDER TO extension
    IF SEEK(cFilext)
       m.secname = secname
       m.cdxname = cdxname
       m.descrip = ALLTRIM(descrip)
    ELSE
       m.secname = ""
       m.cdxname = ""
       m.descrip = ""
    ENDIF       
	  m.fullname = upper( cFileDir+name )
	  m.fullname = SUBSTR(m.fullname,1,RAT(".",m.fullname)-1)
    cWinTitle  = "History for "+m.descrip  +" "+m.fullname
    SELECT (cArea)
    \ECHO ********************** > HISTORY.TXT
    \ECHO <<cFileDir+SUBSTR(name,1,AT(".",name)) + cFilext>> 
    \ECHO <<cFileDir+SUBSTR(name,1,AT(".",name)) + cFilext>> > FILERESP.
    \<<VHISTORY(cFileDir+SUBSTR(name,1,AT(".",name)) + cFilext)>> 
    \COPY history.txt+temp.txt history.txt > temp.
    IF !EMPTY(m.secname) .AND. ;
      FILE(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname ))
      \ECHO ********************** >> HISTORY.TXT
      \ECHO <<cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname )>> > FILERESP.
      \<<VHISTORY(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.secname ))>> 
      \COPY history.txt+temp.txt history.txt > temp.
    ENDIF
    IF !EMPTY(m.cdxname) .AND. ;
      FILE(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname ))
      \ECHO ********************** >> HISTORY.TXT
      \ECHO <<cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname )>> > FILERESP.
      \<<VHISTORY(cFileDir+strtran( upper( name) ,"."+cFilext ,"."+m.cdxname ))>> 
      \COPY history.txt+temp.txt history.txt > temp.
  ENDIF
  \

RETURN (.T.)


* Refresh from Local directory
PROCEDURE rfrhost
RETURN (.T.)


* Create VC.CFG and make STORE directory
PROCEDURE CreaAll
PARAMETERS m.projname,cDir_to_create
PRIVATE cdir,curarea
curarea = SELECT()
cdir = sys(5)+CURDIR()
SET DEFA TO (cDir_to_create)
* Create config file and add line for current project
IF !FILE(cDir_to_create+"VCS.CFG")
************************
SET TEXT ON
SET TEXT TO vcs.cfg NOSHOW ADDITIVE
TEXT
# config_file vcs.cfg
*NOEXPANDKEYWORDS  && Optional
IgnorePath
CheckLock
ARCHIVESUFFIX = $??___
VCSDir=<<SYS(5)+CURDIR()>>STORE
ENDTEXT
***********************
SET TEXT TO
SET TEXT OFF
ENDIF
SELECT (curarea)
*IF !CheckDir(cDir_to_create+"STORE")
=MAKEDIR(cDir_to_create+"STORE")
*ENDIF
SET DEFA TO (cdir)

******
* Test reading of Error File from Checkin/Checkout:
* 02/03/93  (rg)
*    If you remove "*" from delete command after "if lOk"
*    statement, it will delete records for successful entries
*    leaving only the errors (I think this is better...).
*    Note that there can be 1 OR 2 records for an error.
*    We should leave both.
*
* Current directory - cSpecFilDir
*
procedure checktst
private nModRecNo, nCurRec, cModName, lOk, lDone, lFirst,oldarea,wtop
curarea = SELECT()

create table (cWorkFilDir+"chkerr") ( Result C(100) , ;
                      Module C(50) , ;
                      IsError L )

if file( cWorkFilDir+"CHKERR.DBF" )
  use (cWorkFilDir+"CHKERR") excl
  zap
  append from CHKERR.ERR SDF
  *DELETE FILE CHKERR.ERR
  IF RECCOUNT() = 0
     RETURN
  ENDIF   
  go top
  DELETE ALL FOR "PVCS Version Manager" $ result .OR. "INTERSOLV, Inc" $ result
  PACK
  lDone = .F.
  lFirst = .T.
  nModRecNo = recno()  && starting record number
  cModName  = substr( Result, 3 )
  
   lOk = .T.  && indicator that operation was successful

  do while !lDone
    lDone = eof()
    if !lFirst and ( substr( Result, 1, 2 ) = "**" or eof() )
      nCurRec = min( recno(), reccount() )
      goto nModRecNo
      delete   && we don't need "**" indicator record any more...
      do while ( recno() < nCurRec or nCurRec = reccount() ) and !eof()
        replace module with cModName
        replace IsError with !lOK
        if lOk  &&  delete references to OK operations
          * delete  && temporary block for testing
        endif
        skip
      enddo
      goto nCurRec
      nModRecNo = recno()  && starting record number
      cModName  = substr( Result, 3 )
      lOk = .T.
    else
      IF not "**" $ Result 
        IF "New rev" $ Result    
           DO UpdVersions WITH "updated"
        ENDIF
        IF "First revision" $ Result 
           DO UpdVersions WITH "adding"
       ENDIF 
        if "put:" $ Result  .OR. "get:" $ Result .OR. "Fatal error" $ Result
           lOk = .f.
        endif
      ENDIF
    endif
    lFirst = .F.
    skip
  enddo
  pack
else
  wait "Error Opening Checkin/out Error File!" window
endif
SELECT *;
  FROM CHKERR;  
  WHERE IsError;
  INTO CURSOR temperr
  SELECT (curarea)
IF USED("chkerr")
  USE IN chkerr
ENDIF
return


FUNCTION vcstr
* Indicate that module is not a controlled
RETURN("can't locate archive for workfile")

FUNCTION runbatch
* Run batch file
PARAMETERS filename
!&filename
=SETDIR(home_dir)

FUNCTION  UpdVersions
* Update version database for current file
PARAMETERS cMode 
PRIVATE m.projname,m.projdir,nPos, nPos1, m.fullname, ;
     m.date_in, m.time_in, nCount, m.date_mod, m.time_mod,;
     m.userid, nRecno, nPos1, nPos2

nRecno = RECNO()

m.projname = ALLTRIM(db_proje->projname)
m.projdir  = ALLTRIM(db_proje->projdir)

* Create version database if not exist
IF !FILE(m.projdir+m_specdir+"\"+m.projname+".VER")
  CREATE DBF (m.projdir+m_specdir+"\"+m.projname+".VER");
      (FULLNAME C(100), VERSION C(20), ;
       DATE_IN D, TIME_IN C(8), DATE_MOD D, TIME_MOD C(8), ;
        USERID C(3) )
  INDEX ON fullname TO (m.projdir+m_specdir+"\"+m.projname+".VMP")
  USE
ENDIF  

=OPENDBF(m.projdir+m_specdir+"\"+m.projname+".VER","VERSIONS")
SET INDEX TO (m.projdir+m_specdir+"\"+m.projname+".VMP")
SET FILTER TO NOT DELETED()

SELE ChkErr
m.fullname = UpdateName()
IF EMPTY(m.fullname)
  SELE chkerr
  RETURN
ENDIF  
m.date_in    = DATE()
m.time_in    = TIME()
nCount = ADIR(temparr, m.fullname)
m.date_mod   = temparr(1,3)
m.time_mod   = temparr(1,4)
m.time_in    = TIME()  && PVCS does not provide date and time information
m.userid     = m_userid  
m.date_in    = DATE()
IF UPPER(cMode) = "UPDATED"
  Private nPos1, nPos2, nPos3, nPos4, m.version, cDateTime, m.time_in, cDate
  Private cUserid, nDefic1, nDefic2, m.year, m.month, m.day, m.date_in
  m.firstname = SUBSTR(m.fullname,RAT("\",m.fullname)+1)
  ans  = ALLTRIM(chkerr.result)
  nPos1 = AT(SPACE(1),ans,2)
  nPos2 = AT(",",ans)
  IF nPos2 = 0
    m.version = ALLTRIM(SUBSTR(ans,nPos1))
  ELSE
    m.version = ALLTRIM(SUBSTR(ans,nPos1,nPos2-nPos1))
  ENDIF   
ELSE
       m.version = "1.0"
ENDIF
SELE versions
IF SEEK(m.fullname)
       GATHER MEMVAR
ELSE
       INSERT INTO versions FROM MEMVAR
ENDIF  
SELE ChkErr  
IF nRecno <= RECCOUNT()
  GOTO nRecno
ENDIF  

FUNCTION UpdateName
PRIVATE nRecno,m.ret_val
nRecno = RECNO()
DO WHILE NOT "**" $ Result
  SKIP -1
  IF EOF()
    GOTO nRecno 
    RETURN ("")
  ENDIF
ENDDO
m.ret_val = UPPER(ALLTRIM(SUBSTR(Result,3)))
GOTO nRecno 
RETURN(m.ret_val)

FUNCTION vertrack
* Create version list
PRIVATE cName, ans,cMemo,nArea, nStart, nEnd, lFirstTime, cComment   
PRIVATE cPos, cPos1, m.Version, m.Userid, cDateTime, cLine, ;
m.date_in, m.time_in, m.comment

cMemo = SET("MEMO")
SET MEMO TO 100

SELE 0
CREATE CURSOR VERHIST ;
( VERSION C(5), DATE_IN D, TIME_IN C(8), USERID C(3), COMMENT C(130) )

SELE 0
CREATE CURSOR TempMemo ( temp M)
APPEND BLANK
APPEND MEMO temp FROM HISTORY.TXT

nStart  = atcline(m.firstname, temp)+2
IF !EMPTY(m.secname)
  nEnd    = atcline(m.secname ,temp)-2
ELSE
  nEnd    = MEMLINES(temp)
ENDIF

lFirstTime = .T.
m.Comment = ""
WAIT WINDOW "Creating version database..." NOWAIT 

FOR i = nStart TO nEnd
  ans   = MLINE(temp,i)
  DO CASE
    CASE "Rev" $ ans
       * Beginning of new record
       m.version = ALLTRIM(SUBSTR(ans,AT("Rev",ans)+4))
       m.Comment = ""
    CASE "Checked in:" $ ans
       * Time module was checked out
       ans = ALLTRIM(SUBSTR(ans,AT("Checked in:",ans)+12))
       nSpace1 = AT(" ",ans,1)
       nSpace2 = AT(" ",ans,2)
       nSpace3 = AT(" ",ans,3)
       nSpace4 = AT(" ",ans,4)
       nLen    = LEN(ans)+1
       m.day   = ALLTRIM(SUBSTR(ans,1,nSpace1))
       m.month   = fMonth(ALLTRIM(SUBSTR(ans,nSpace1,nSpace3-nSpace2)))
       m.year    = ALLTRIM(SUBSTR(ans,nSpace2,nSpace3-nSpace2))
       m.date_in    = CTOD(m.month+"/"+m.day+"/"+m.year)
       m.time_in    = ALLTRIM(SUBSTR(ans,nSpace3,nLen -nSpace3))
    CASE  "Last modified:" $ ans
    CASE "Author id:" $ ans
       * Author id
       m.Userid = ALLTRIM(SUBSTR(ans,AT("Author id:",ans)+11))
       m.Userid = ALLTRIM(SUBSTR(m.Userid,1,AT("lines",m.Userid)))
    CASE "----" $ ans
       * End of record
       INSERT INTO VERHIST FROM MEMVAR
    CASE "====" $ ans
       * End of file
       INSERT INTO VERHIST FROM MEMVAR
    OTHERWISE
       * Comments
       m.Comment = m.Comment+ans
  ENDCASE     
ENDFOR

SELE verhist
WAIT CLEAR
SET MEMO TO (cMemo)

FUNCTION UpdateTempCursor
PRIVATE m.name, nLine, ans,nArea
PRIVATE nSpace1,nSpace2,nSpace3,nSpace4,nSpace5,nPos, nPos1, nPos2
PRIVATE m.year, m.month, m.day 
PRIVATE cName, ans,cMemo,nArea, nStart, nEnd, lFirstTime, cComment   
PRIVATE nPos, nPos1, cVer, cUserid, cDateTime, cLine, cAns, cDate, cTime
nArea = SELECT()
m.fullname =  ALLTRIM(fullname)
IF ".STR" $ UPPER(module)
  m.fullname = STRTRAN(m.fullname,".DBF",".STR")
ENDIF  

SELE headers
SET ORDER TO name
IF NOT SEEK("**"+m.fullname)
   SET ORDER TO
   SELECT (nArea)
   RETURN (.T.)
ENDIF   
SET ORDER TO

IF !EOF()
  m.nRecno = headers.nrecno 
  SELE tempstat
  GOTO m.nRecno
  * Beggining of the version record
  SKIP
  IF "vlog:" $ name .OR. "ERROR:" $ UPPER(name)
     m.error = name
     SELE (nArea)
     RETURN (.T.)
  ENDIF   
  DO WHILE NOT "Rev" $ tempstat.name 
    SKIP
  ENDDO
  m.version = ALLTRIM(STRTRAN(tempstat.name,"Rev",""))
  DO WHILE NOT "Checked in:" $ tempstat.name
    SKIP 
  ENDDO
  m.cDatetime = ALLTRIM(STRTRAN(tempstat.name,"Checked in:" ,""))
  nSpace1 = AT(" ",m.cDatetime,1)
  nSpace2 = AT(" ",m.cDatetime,2)
  nSpace3 = AT(" ",m.cDatetime,3)
  nSpace4 = AT(" ",m.cDatetime,4)
  nLen    = LEN(m.cDatetime)+1
  m.day   = ALLTRIM(SUBSTR(m.cDatetime,1,nSpace1))
  m.month   = fMonth(ALLTRIM(SUBSTR(m.cDatetime,nSpace1,nSpace3-nSpace2)))
  m.year    = ALLTRIM(SUBSTR(m.cDatetime,nSpace2,nSpace3-nSpace2))
  m.date    = CTOD(m.month+"/"+m.day+"/"+m.year)
  m.time    = ALLTRIM(SUBSTR(m.cDatetime,nSpace3,nLen -nSpace3))
  DO WHILE NOT "Author id:" $ tempstat.name
    SKIP
  ENDDO
  nSpace2 = AT(" ",tempstat.name,2)
  nSpace3 = AT(" ",tempstat.name,3)
  m.userid = ALLTRIM(SUBSTR(tempstat.name,nSpace2,nSpace3-nSpace2)) 
ELSE
  SELE tempstat
  GOTO BOTTOM
ENDIF

SELECT (nArea)
RETURN (.T.)

FUNCTION fMonth
PARAMETERS m.month
nMonth = "??"
m.month = upper( m.month ) &&  09/28/94 (rg)
    DO CASE
      CASE m.month = "JAN"       
         nMonth = "01"
      CASE m.month = "FEB"      
         nMonth = "02"
      CASE m.month = "MAR"      
         nMonth = "03"
      CASE m.month = "APR"      
         nMonth = "04"
      CASE m.month = "MAY"      
         nMonth = "05"
      CASE m.month = "JUN"      
         nMonth = "06"
      CASE m.month = "JUL"      
         nMonth = "07"
      CASE m.month = "AUG"
         nMonth = "08"
      CASE m.month = "SEP"
         nMonth = "09"
      CASE m.month = "OCT"
         nMonth = "10"
      CASE m.month = "NOV"
         nMonth = "11"
      CASE m.month = "DEC"
         nMonth = "12"
      ENDCASE      
RETURN(nMonth)





